#Copyright 2006 DR0ID <dr0id@bluewin.ch> http://mypage.bluewin.ch/DR0ID
#
#
#
"""
#TODO: documentation!
"""

__author__ = "$Author: DR0ID $"
__version__= "$Revision: 56 $"
__date__   = "$Date: 2006-09-09 16:09:45 +0200 (Sa, 09 Sep 2006) $"


import controller 
import animation 
import os

cabinet = controller.Controller('cabinet')
cabinet.state = 0
class ActionDoorOpen(controller.Action):
    
    def __init__(self):
        controller.Action.__init__(self, 'openDoor')
        
    def run(self, *args):
        controller.Action.run(self, *args)
        if self.cabinet.state ==0:
            self.cabinet.state=1
            self.cabinet.door.visible = 1
            self.cabinet.door.setAnim('openDoor')
            self.cabinet.body.setAnim('still')
            return 0
        else:
            print self.parent.name,".",self.name,"cant open cabinet door, its already open"
        return 1
            
class ActionDoorClose(controller.Action):
    
    def __init__(self):
        controller.Action.__init__(self, 'closeDoor')
        
    def run(self, *args):
        controller.Action.run(self, *args)
        if self.cabinet.state ==1:
            self.cabinet.state=0
            self.cabinet.door.setAnim('closeDoor')
            self.cabinet.door.layer = 5
            self.cabinet.door.play()
            self.cabinet.body.setAnim('still')
            return 0
        else:
            print self.parent.name,".",self.name,"cant close cabinet door, its already closed"
        return 1

class ActionSpin(controller.Action):
    
    def __init__(self):
        controller.Action.__init__(self, 'spin')
        
    def run(self, *args):
        controller.Action.run(self, *args)
        if self.cabinet.state ==0:
            self.cabinet.state=0
            self.cabinet.door.visible = 0
##            self.cabinet.door.play()
            self.cabinet.body.setAnim('spin')
            return 0
        else:
            print self.parent.name,".",self.name,"cant spin, door open"
        return 1

cabinet.addaction( ActionSpin() )
cabinet.addaction( ActionDoorClose() )
cabinet.addaction( ActionDoorOpen() )

class Door(controller.Part):
    
    def __init__(self):
        controller.Part.__init__(self, "door")
        self.state = 0 # 0 door closed, 1 door open
        self.layer = 5
        
    def openDoor(self):
        if self.state == 0:
            self.state = 1
            self.animation = self.animations['openDoor']
            self.animation.play()
        
    def closeDoor(self):
        if self.state == 1:
            self.state = 0
            self.animation = self.animations['closeDoor']
            self.animation.play()
        

class CabinetBody(controller.Part):
    
    def __init__(self):
        controller.Part.__init__(self, 'body')
        
    def spin(self):
        if self.state ==0:
            self.animation = self.animations['spin']
            self.animation.play()
        else:
            print "cant spin cabinet wiht open door"


cabinetbody = CabinetBody()   

imgs = animation.load_img_from_dir(os.path.join('data', 'cabinet', 'body', 'spin'), 0)
animation.set_colorkeys(imgs, imgs[0].get_at((0,0)))
anim = animation.Animation((400,300), imgs, 10)
cabinetbody.addAnim( 'spin', anim  )

imgs = animation.load_img_from_dir(os.path.join('data', 'cabinet', 'body', 'still'), 0)
animation.set_colorkeys(imgs, imgs[0].get_at((0,0)))
anim = animation.Animation((400,300), imgs, 10)
cabinetbody.addAnim( 'still', anim  )


door = Door()
imgs = animation.load_img_from_dir(os.path.join('data', 'cabinet', 'Door'), 0)
animation.set_colorkeys(imgs, imgs[0].get_at((0,0)))
anim = animation.Animation((400,300), imgs, 10)
door.addAnim( 'openDoor', anim  )

rimgs = animation.reverse_images(imgs)

ranim = animation.Animation((400,300), rimgs, 10)
door.addAnim('closeDoor', ranim)

door.animation = door.animations['openDoor']

cabinet.addObject(door)
cabinet.addObject(cabinetbody)
cabinet.moveto( (400,300))
cabinet.body.setAnim('still')
##print "------------------>", cabinet.actions

del imgs
del anim
del ranim
