#Copyright 2006 DR0ID <dr0id@bluewin.ch> http://mypage.bluewin.ch/DR0ID
#
#
#
"""
#TODO: documentation!
"""

__author__ = "$Author: DR0ID $"
__version__= "$Revision: 56 $"
__date__   = "$Date: 2006-09-09 16:09:45 +0200 (Sa, 09 Sep 2006) $"






class Action(object): #scene scripting
    
    def __init__(self, name):
        object.__init__(self)
        self.scene = None
        self.name = name
        
    def setname(self, obj, name):
        setattr(self, name, obj)
        
    def run(self, *args): #-> bool 0 ok, 1 use default
        print self.parent.name,"action", self.name, "run() with args", args

        # commands like
        # self.scene.wizard.head.doaction("losebeard")
        # self.scene.wizard.doaction("move", (dx, dy))
    
class Wait(Action):
    
    def __init__(self):
        Action.__init__(self, 'wait')
        
    def run(self, *args):
        Action.run(self, *args)
        print "----------------<Wait action: ", args
        for c in self.parent.children:
            c.wait(args[0])

class Part(object):

    scene = None
    
    def __init__(self, name):
        object.__init__(self)
        self.name = name
        self.state = 0
        self.pos = [0,0]
        self._wait = 0
        self.animation = None
        self.animations = {} # {name: anim}
        self.visible = 1
        self.parent = None
##        self.animname = ''
        self.layer = 1
        self.movelist = []
        
    def wait(self, sec=0):
        self._wait = sec*30 #frames
        print self.name, "waiting ", self._wait
        
    def play(self, centerpos=None, loop=False):
        if self.animation is not None:
            self.animation.play(centerpos, loop)
        
##    def move(self, dx, dy):
##        for a in self.animations.values():
##            a.rect.move_ip(dx, dy)
##            a.pos = a.rect.center

    def move(self, pos, t):
        print "moveto",self.pos, pos, t
        
        self.movelist = []
        x, y = pos
        steps = t*15
        print steps
        dx = (x-self.pos[0])/float(steps)
        dy = (y-self.pos[1])/float(steps)
        print "dx,dy------>", dx, dy
        for i in range(steps):
            self.movelist.append((round(dx),round(dy)))

            
    def moveto(self, pos):
        for a in self.animations.values():
            a.rect.center = pos
        self.pos = list(pos)

    def update(self, dt):
##        print self.__class__, self.name, "update()"
        if self._wait>0:
            self._wait -= 1
            return 1
        if self.animation is not None:
            if len(self.movelist)>0:
##                print self.__class__, "update, movingto", self.movelist[0]
                p = self.movelist.pop(0)
                self.pos[0] += p[0]
                self.pos[1] += p[1]
                self.animation.pos = self.pos
                self.animation.play()
            return self.animation.update(dt)
        
        else:
            return 0
    
    def draw_run(self, drawer):
        if self.animation is not None:
            if self.visible:
                layer = self.layer
##                print layer
                if not drawer.layers.has_key(layer):
                    drawer.layers[layer] = []
                drawer.layers[layer].append(self)
##                print "===>", self.name, self.pos, self.animation.pos
        
    def addAnim(self, name, anim):
        self.animations[name] = anim
        
    def show(self):
        self.visible = 1
        
    def hide(self):
        self.visible = 0
        
    def setAnim(self, name, play=1):
        try:
            self.animation = self.animations[name]
            self.animation.reset()
            self.animation.pos = self.pos
            if play:
                self.play()
        except:
            print "ERROR:", self.name, "could not set animation", name, "available:", self.animations.keys()
            self.animation = None
        
        
        




class Controller(object):

    scene = None
    
    def __init__(self, name):
        self.name = name
        self.actions = {} # {name:action}
        self.children = []
        self.actionqueue = []
##        self.pos = [0,0]
        self.addaction(Wait())
        self.layers = {}
        self.state = 0
      
    def addaction(self, action):
        print self.name, " adding action ", action.name
        self.actions[action.name] = action
        action.setname(self, self.name)
        action.parent = self
        action.scene = self.scene
        
    def addObject(self, obj):
        setattr(self, obj.name, obj)
        self.children.append(obj)
        obj.parent = self
        obj.scene = self.scene
        
    def removeObject(self, name):
        try:
            self.children.remove(getattr(self, name))
            delattr(self, name)
        except:
            pass
      
    def move(self, dx, dy):
        for child in self.children:
            child.move(dx, dy)
        self.pos[0] += dx
        self.pos[1] += dy
        
    def moveto(self, pos):
        for child in self.children:
            child.moveto(pos)
        self.pos = list(pos)
    
    def update(self, dt):
        # anim trigger here for anoyng animations
##        print self.__class__, self.name, "update()"
        res = 0
        for child in self.children:
##            print self.name, "going to updat child", child.name
            res = (child.update(dt) or res)
##            res = child.update(dt)
            
        if res == 0 and len(self.actionqueue)>0:
            cmd = self.actionqueue.pop(0)
##            print self.name, "going to run aciton ", cmd
            try:
                self.actions[cmd[0]].run(*cmd[1])
                print self.name, "action ", cmd[0], " done"
            except Exception, inst:
                #TODO default action
                print "ERROR: ",self.name," action failed: ",cmd, "available actions", self.actions.keys()
                print "        reason:", inst
        return res
        
    def draw(self, scr):
        self.draw_run(self)
        lay = self.layers.keys()
        lay.sort()
        for l in lay:
            for a in self.layers[l]:
                a.animation.draw(scr) 
        self.layers = {}        
        
    def draw_run(self,drawer):
        for child in self.children:
            child.draw_run(drawer)
            
    def wait(self, t):
        for c in self.children:
            c.wait(t)
            
    def doaction(self, spellname, *args):
        print self.name, "action ", spellname, " added"
        self.actionqueue.append((spellname, args,))
    
 
