#Copyright 2006 DR0ID <dr0id@bluewin.ch> http://mypage.bluewin.ch/DR0ID
#
#
#
"""
#TODO: documentation!
"""

__author__ = "$Author: DR0ID $"
__version__= "$Revision: 56 $"
__date__   = "$Date: 2006-09-09 16:09:45 +0200 (Sa, 09 Sep 2006) $"


import controller
import animation
import os

class Wizardanim(controller.Part):
    
    def __init__(self):
        controller.Part.__init__(self, 'anim')
        self.state = 0

        scale = 1
        
        imgs = animation.load_img_from_dir(os.path.join('data', 'wizard', 'walk'), 1, scale)
##        animation.set_colorkeys(imgs)
        anim = animation.Animation((0,0), imgs, 15)
        self.addAnim( 'walkL', anim )
        
        imgs = animation.flip_images(imgs)
        anim = animation.Animation((0,0), imgs, 15)
        self.addAnim( 'walkR', anim )
        

        imgs = animation.load_img_from_dir(os.path.join('data', 'wizard', 'rot'), 1, scale)
        animation.set_colorkeys(imgs)
        anim = animation.Animation((0,0), imgs, 15)
        self.addAnim( 'rotFtoR', anim )

        imgs = animation.reverse_images(imgs)
        anim = animation.Animation((0,0), imgs, 15)
        self.addAnim( 'rotRtoF', anim )
        
        imgs = animation.flip_images(imgs)
        anim = animation.Animation((0,0), imgs, 15)
        self.addAnim( 'rotLtoF', anim )
        
        imgs = animation.reverse_images(imgs)
        anim = animation.Animation((0,0), imgs, 15)
        self.addAnim( 'rotFtoL', anim )
        
        
##        imgs = animation.load_img_from_dir(os.path.join('data', 'wizard', 'spelling'), 1, scale)
##        animation.set_colorkeys(imgs)
##        anim = animation.Animation((0,0), imgs, 15)
##        self.addAnim( 'spelling', anim )
        
        imgs = animation.load_img_from_dir(os.path.join('data', 'wizard', 'bow'), 1, scale)
        for i in range(2):
            imgs.append(imgs[-1])
        imgs.extend(animation.reverse_images(imgs))
        animation.set_colorkeys(imgs)
        anim = animation.Animation((0,0), imgs, 15)
        self.addAnim( 'bow', anim )
        
##        imgs = animation.load_img_from_dir(os.path.join('data', 'wizard', 'loosePants'), 1, scale)
##        animation.set_colorkeys(imgs)
##        anim = animation.Animation((0,0), imgs, 15)
##        self.addAnim( 'loosePants', anim )
        
        
        
##states
##0: R
##1: F
##2: L



class ActionWalk(controller.Action):
    
    def __init__(self):
        controller.Action.__init__(self,'walk')
        
    def run(self, *args):
        controller.Action.run(self, *args)
        w = self.parent
        print "ActionWalk args: ", args
        if len(args)==0:
            print "ERROR: ", self.parent.name, self.name, "cant walk,  no arguments"
            return 1
        dx = args[0][0]
        if dx>0:
            if w.state!=0:
                w.doaction('rottoR')
        else:
            if w.state !=2:
                w.doaction('rottoL')
        w.doaction('dowalk', *args)
        
class ActiondoWalk(controller.Action):
    
    def __init__(self):
        controller.Action.__init__(self, 'dowalk')
        
    def run(self, *args):
        controller.Action.run(self, *args)
        if len(args)==0:
            print "ERROR: ", self.parent.name, self.name, "cant walk,  no arguments"
            return 1
        w = self.parent
        if w.state==2:
            w.anim.setAnim('walkL')
            w.anim.move(args[0], args[1])
        elif w.state==0:
            w.anim.setAnim('walkR')
            w.anim.move(args[0], args[1])
        return 0


class ActionSpelling(controller.Action):
    
    def __init__(self):
        controller.Action.__init__(self,'spelling')
        
    def run(self, *args):
        controller.Action.run(self, *args)

class ActionBow(controller.Action):
    
    def __init__(self):
        controller.Action.__init__(self,'bow')
        
    def run(self, *args):
        controller.Action.run(self, *args)
        w = self.parent
        if w.state==1:
            w.anim.setAnim('bow')

class ActionRotLtoF(controller.Action):
    
    def __init__(self):
        controller.Action.__init__(self,'rotLtoF')
        
    def run(self, *args):
        controller.Action.run(self, *args)
        w = self.parent
        if w.state ==2:
            w.state = 1
            w.anim.setAnim('rotLtoF')

class ActionRotRtoF(controller.Action):
    
    def __init__(self):
        controller.Action.__init__(self,'rotRtoF')
        
    def run(self, *args):
        controller.Action.run(self, *args)
        w = self.parent
        if w.state==0:
            w.state = 1
            w.anim.setAnim('rotRtoF')
        
class ActionrotFtoL(controller.Action):
    
    def __init__(self):
        controller.Action.__init__(self,'rotFtoL')
        
    def run(self, *args):
        controller.Action.run(self, *args)
        w = self.parent
        if w.state == 1:
            w.state = 2
            w.anim.setAnim('rotFtoL')
        
class ActionrotFtoR(controller.Action):
    
    def __init__(self):
        controller.Action.__init__(self,'rotFtoR')
        
    def run(self, *args):
        controller.Action.run(self, *args)
        w = self.parent
        if w.state== 1:
            w.state = 0
            w.anim.setAnim('rotFtoR')
        
        
class ActionrottoR(controller.Action):
    
    def __init__(self):
        controller.Action.__init__(self,'rottoR')
        
    def run(self, *args):
        controller.Action.run(self, *args)
        w = self.parent
        if w.state ==2:
            w.doaction('rotLtoF')
        if w.state== 1 or w.state==2:
            w.doaction('rotFtoR')
            
            
        
class ActionrottoF(controller.Action):
    
    def __init__(self):
        controller.Action.__init__(self,'rottoF')
        
    def run(self, *args):
        controller.Action.run(self, *args)
        w = self.parent
        if w.state== 0:
            w.doaction('rotRtoF')
        elif w.state==2:
            w.doaction('rotLtoF')
            
class ActionrottoL(controller.Action):
    
    def __init__(self):
        controller.Action.__init__(self,'rottoL')
        
    def run(self, *args):
        controller.Action.run(self, *args)
        w = self.parent
        if w.state==0:
            w.doaction('rotRtoF')
        if w.state== 1 or w.state==0:
            w.doaction('rotFtoR')
       
        
class ActionloosePants(controller.Action):
    
    def __init__(self):
        controller.Action.__init__(self,'loosePants')
        
    def run(self, *args):
        controller.Action.run(self, *args)
        

wizard = controller.Controller("wizard")
wizard.addObject(Wizardanim())

wizard.addaction(ActionWalk())
wizard.addaction(ActionSpelling())
wizard.addaction(ActionBow())
wizard.addaction(ActionrottoL())
wizard.addaction(ActionrottoR())
wizard.addaction(ActionrottoF())
wizard.addaction(ActionloosePants())
wizard.addaction(ActiondoWalk())
wizard.anim.setAnim('walkR', 0)
wizard.moveto((0, 200))

##wizard.addObject(head)





# TODO: add all needed part to the wizard